/******************************************************************************
	x̎ PI								2010 Masaji Kasahara
******************************************************************************/

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <math.h>
#include <uart.h>
#include <ctype.h>
#include "my.h"

_FOSCSEL(FNOSC_FRC);		// NFRCB(NPLLɐ؂ւ)
_FOSC(POSCMD_NONE & OSCIOFNC_ON & FCKSM_CSECMD & IOL1WAY_OFF);
_FWDT(FWDTEN_OFF);			// EHb`hbO^C}֎~

#define PERIOD 1575			// }X^[^Cx[X XCb`Og600kHz

#define Kp	11.2			// Xebv@ŋ߂PI萔
#define Ti	600.0
#define Td	0				// (PIȂ̂ŁAĎW̓[)
#define Kpp	Kp/50.0			// j[50%ɐݒ肷ƁAXebv@̒萔
#define Kii	Kp/Ti/50.0
#define Kdd	Kp*Td/50.0

// menu[`ŎgϐB
MENU_VAL P=50, I=50, D=0;	// PIDp[^
MENU_VAL ref=50;			// ڕWl[]
#define MENU_NO	3
struct menu_dat menu_dats[MENU_NO] = {
	// type,        str, *value, max,min,row,column,curpos
	{ INT_MENU,    "99",   &P,    99,  0,  0,    6,    0  },
	{ INT_MENU,    "99",   &I,    99,  0,  0,   10,    0  },
	{ INT_MENU,    "80",  &ref,   80,  0,  1,    1,    1  }
};


int main( void )
{
	int wait1sec;
	init();								// 
	lcd_init();		//LCD
	LCD_LOCATE( 0, 0 );	lcd_str( "PI   P50 I50    " );	// j[\
	LCD_LOCATE( 1, 0 );	lcd_str( "R50 M55.5 H97.0%" );

	while(1){
		menu( menu_dats, MENU_NO );		// [U[C^tF[X(10ms|)
		
		if( wait1sec++ > 100 ){			// 1bɈA
			wait1sec = 0;
			thermo_cont_PID();			// x֐sB
		}
	}
}


void thermo_cont_PID( void )
{
	float thermistor_ohm, x, thermistor_deg;
	float err, err_diff, PIDout;
	static float err_integ, before_err;	// static:ĂяoꂽɒloĂ
	char buf[10];

	thermistor_ohm = 8.2E3 * 1023 / ADCBUF1 - (8.2E3 + 220);	// T[~X^̒Rl
	x = log10( thermistor_ohm );
	thermistor_deg  =  -1.7386*x*x*x + 31.966*x*x - 233.33*x + 558.11;	// 

	err = ref - thermistor_deg;		// 덷
	err_integ += err;				// 덷ϕ
	err_diff = err - before_err;	// 덷
	before_err = err;
	
	PIDout  =  err * P * Kpp  +  err_integ * I * Kii  +  err_diff * D * Kdd;

	if(PIDout>60)		// o͓d͂ACA_v^̍őd͈ȉɐ
		PIDout = 60;
	else if(PIDout<1)	// pXȂNJW4800FLTƂɕAłȂ̂Ő
		PIDout = 1;
	
	PDC2 = PERIOD * PIDout / 100;

	itoa_f( "00.0", PIDout * 10, buf );
	LCD_LOCATE( 1, 11 );
	lcd_str( buf );
	putsUART1( (unsigned int *)buf );
	putsUART1( (unsigned int *)", " );

	itoa_f( "00.0", thermistor_deg * 10, buf );
	LCD_LOCATE( 1, 5 );
	lcd_str( buf );
	putsUART1( (unsigned int *)buf );
	putsUART1( (unsigned int *)"\r\n" );
}


void init( void )
{
	unsigned int baudvalue, U1MODEvalue, U1STAvalue;
	SET_CPU_IPL( 7 );				// 荞݋֎~
	Nop();
	NJW4800_STBY = 1;
	TRISA = 0x0007;					// 1̃rbg͓̓s
	TRISB = 0xC741;					// 1̃rbg͓̓s

	// NbNFRC+PLLɐ؂ւ39.6MIPSɂ
	// (IV[^{}jAp42-23,42-2)
	PLLFBD = 41;					// PLL M = 43
	CLKDIVbits.PLLPOST = 0;			// PLL N1 = 2
	CLKDIVbits.PLLPRE = 0;			// PLL N2 = 2
	__builtin_write_OSCCONH(0x01);	// FRC+PLLɐ؂ւJn
	__builtin_write_OSCCONL(0x01);
	while(OSCCONbits.COSC != 0b001);// NbN؂ւ҂
	while(OSCCONbits.LOCK != 1);	// PLLbN҂

	// ADC/PWMW[p⏕NbN(ACLK)FRC+⏕PLL(16{)117.9MHzɂ
	ACLKCONbits.FRCSEL = 1;			// ⏕PLLFRC
	ACLKCONbits.SELACLK = 1;
	ACLKCONbits.APSTSCLR = 7;
	ACLKCONbits.ENAPLL = 1;			// ⏕PLLCl[u
	while(ACLKCONbits.APLLCK != 1);	// ⏕PLLbN҂
	
	// PWMݒ({\tgłPWM1o͎͂gȂ̂ŁAPWM1pݒ̓RgAEg)
//	PWMCON1bits.ITB = 0;		// }X^[^Cx[X[h
	PWMCON2bits.ITB = 0;
//	PWMCON1bits.CAM = 0;		// GbWAC[h
	PWMCON2bits.CAM = 0;
//	IOCON1bits.PMOD = 0;		// o̓[h
	IOCON2bits.PMOD = 0;
	PTCONbits.PTEN  = 1;		// PWMW[L
//	PWMCON1bits.DTC = 2;		// fbh^C@\
	PWMCON2bits.DTC = 2;
	PTPER = PERIOD;				// }X^[^Cx[XXCb`Og600kHz
	IOCON1bits.PENH = 1;		// PWMW[PWM1H/PWM2Hs𐧌
	IOCON2bits.PENH = 1;
	
	// A/DRo[^ TvO()
	ADCONbits.EIE = 0;			// ADCyAϊIĂ犄荞
	ADCONbits.FORM = 0;			// A/Dʂ0:unsigned int/1:Œ菬
	ADCONbits.SLOWCLK = 1;		// ACLK(117.92M)gp(Gb^FK1ɂ邱)
	ADCONbits.ADCS = 4;			// ADNbNFADC/5 = 23.584MHz
	TRIG1bits.TRGCMP = 0;		// PWMWFl[^1APWMʑ0ŃgKo
	TRGCON1bits.TRGDIV = 13;	// PWMpX141TvO(42.9ksps)
	_TRGSRC0 = 4;				// PWMWFl[^11gKADCyA0(AN0,AN1)ϊ
//	_TRGSRC1 = 4;				// PWMWFl[^11gKADCyA1(AN2,AN3)ϊ
//	_TRGSRC2 = 4;				// PWMWFl[^11gKADCyA2(AN4,AN5)ϊ
	ADPCFG = 0;					// SAiO̓sADCƂĎgpAiO[h
	ADCONbits.ADON = 1;			// ADCW[Cl[u

	NJW4800_STBY = 0;			// NJW4800o͊Jn

	// UART1
	RPOR3bits.RP7R = 3;			// RP7U1TXo
	CloseUART1();
	baudvalue = 85;				// 39.6MIPS/115200bps/4-1 (BRGH=1)
	U1MODEvalue =   UART_EN & UART_IDLE_CON & UART_IrDA_DISABLE
				& UART_MODE_FLOW & UART_UEN_00		// CTS, RTSsgp
				& UART_DIS_WAKE & UART_DIS_LOOPBACK
				& UART_EN_ABAUD
				& UART_UXRX_IDLE_ONE				// Mɐ:U1RXAChԂu1vƂ
				& UART_BRGH_FOUR					// BRG[h BRGH=1
				& UART_NO_PAR_8BIT & UART_1STOPBIT;	// peBAf[^8bitAXgbv1bit
	U1STAvalue  =   UART_INT_TX_BUF_EMPTY			// (荞݂͎gȂ̂ŋCɂȂ)
				& UART_IrDA_POL_INV_ZERO			// Mɐ:U1TXAChԂu1vƂ
				& UART_SYNC_BREAK_DISABLED			// u[NI
				& UART_TX_ENABLE					// TxsL
				& UART_INT_RX_3_4_FUL				// (荞݂͎gȂ̂ŋCɂȂ)
				& UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR;
	OpenUART1(U1MODEvalue, U1STAvalue, baudvalue);

	RCON=0;		// sӂɃZbgƂɃfobKRCON𒲂ׂƗv
}
