/******************************************************************************
	LCDj[\
******************************************************************************/

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "my.h"

static int getkey()		// L[́Bo@\t
{
	static int sum_keydat;
	int keydat = (~PORTB) & 0xC100;		// ĂȂ0
	delay(10000);						// `^O(10msfBC)

	if( sum_keydat!=0 && keydat==0 ){ 	// SẴL[wꂽ
		int return_keydat = sum_keydat;
		sum_keydat = 0;
		return( return_keydat );
	}
	sum_keydat |= keydat;
	return( 0 );
}

char *itoa_f( const char *format_str, long value, char *out ) // 𕶎
{
	long abs_value = labs(value);
	int zerosuppress = FALSE;
	int n = strlen( format_str );
	char *cp = out + n;
	strcpy( out, format_str );

	for(; n; n--){
		cp--;
		if( !isdigit(*cp) )
			continue;

		*cp = (abs_value % 10) + '0';
		if( zerosuppress && (abs_value==0) )
			*cp = ' ';

		abs_value = abs_value / 10;
		
		if( cp[1] == '.' )
			zerosuppress = TRUE;
	}
	return( out );
}

static int menu_dispi( struct menu_dat *menu )	// \
{
	MENU_VAL value = labs(*menu->value);
	int zerosuppress = FALSE;
	int curcolumn, curpos = menu->curpos;
	int n = strlen( menu->str );
	char buf[15], *cp = buf + n;
	strcpy( buf, menu->str );

	for(; n; n--){
		cp--;
		if( *cp==',' || *cp=='.' )
			continue;
		if( *cp=='+' ){
			if( *menu->value < 0 )
				*cp = '-';
			else if( *menu->value == 0 )
				*cp = ' ';
			continue;
		}

		*cp = (value % 10) + '0';
		if( zerosuppress && (value==0) )
			*cp = ' ';

		value = value / 10;
		
		if( cp[1] == '.' )
			zerosuppress = TRUE;
		if( curpos-- == 0 )
			curcolumn = menu->column + n - 1;
	}
	LCD_CUROFF;
	LCD_LOCATE( menu->row, menu->column );
	lcd_str( buf );
	LCD_LOCATE( menu->row, curcolumn );
	LCD_CURON;
	if( curpos >= 0 )							// J[\ɂ͂ݏo
		return( LEFT_KEY );
	return(0);
}

static int menu_i( struct menu_dat *menu )	// 
{
	MENU_VAL delta = 1, value = *menu->value;
	int key = getkey(), i;
	menu_dispi( menu );
	for( i=menu->curpos; i; i-- )
		delta *= 10;

	if( key == UP_KEY ){
		value += delta;
		if( value > menu->max )
			value = menu->max;
		DIS_INTERRUPT;			// 荞݋֎~
		*menu->value = value;
		ENA_INTERRUPT;			// 荞݋
		menu_dispi( menu );
	}
	else if( key == DOWN_KEY ){
		value -= delta;
		if( value < menu->min )
			value = menu->min;
		DIS_INTERRUPT;			// 荞݋֎~
		*menu->value = value;
		ENA_INTERRUPT;			// 荞݋
		menu_dispi( menu );
	}
	else if( key == LEFT_KEY ){
		menu->curpos++;
		if( menu_dispi( menu ) ){
			menu->curpos--;
			return( LEFT_KEY );
		}
		key = 0;
	}
	else if( key == RIGHT_KEY ){
		if( menu->curpos ){
			menu->curpos--;
			menu_dispi( menu );
		}
		else
			return( RIGHT_KEY );
		key = 0;
	}
	return( key );
}

static int menu_select( struct menu_dat *menu )	// Ij[
{
	int key = getkey();
	int i;
	char *cp = menu->str;
	if( key & (UP_KEY | DOWN_KEY) )
		++ *menu->value;

	for( i = *menu->value; i; i-- ){
		cp = strchr( cp, ',' );
		if( cp == NULL ){
			*menu->value = 0;
			cp = menu->str;
			break;
		}
		cp++;
	}
	LCD_CUROFF;
	LCD_LOCATE( menu->row, menu->column );
	while( *cp && *cp!=',' )
		lcd_data( *cp++ );
	LCD_LOCATE( menu->row, menu->column );
	LCD_CURON;
	return( key );
}

void menu(struct menu_dat *menu_dats, int menu_no )
{
	int key;
	static int n=0;
	if( menu_dats[n].type == INT_MENU )
		key = menu_i( menu_dats + n );
	else
		key = menu_select( menu_dats + n );

	if( key == SEL_KEY ){
		if( n++ >= menu_no-1 )
			n=0;
	}
}
