
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ		BLMotorCtrl.h
//	CPU			dsPIC33FJ16GS502
//	e		Ӱ̒萔,ϐ,׸,֐̒`


///////////////////////////////////////////////////////////////////////////////
// 

#define		OUT					0				// o
#define		IN					1				// 

#define		ON					1
#define		OFF					0

#define		HIGH				1
#define		LOW					0

#define		HIGHOFF				1
#define		LOWON				0

#define		ENABLE				1				// 
#define		DISABLE				0				// ֎~

#define		STOP_MODE			0				// ~Ӱ
#define		CTRL_MODE			1				// Ӱ


///////////////////////////////////////////////////////////////////////////////
// IO߰Ă̖

#define		STBY		LATAbits.LATA3			// DD Con STBY

#define		SW1			PORTBbits.RB8			// SW1
#define		SW2			PORTBbits.RB15			// SW2
#define		SW3			PORTBbits.RB14			// SW3

#define		LED			LATBbits.LATB5			// LED

#define		LCD_E		LATBbits.LATB11			// LCD E
#define		LCD_RS		LATBbits.LATB12			// LCD RS


///////////////////////////////////////////////////////////////////////////////
// ϊ֌W

// ϐݒ

#define		TM1_CNT				3963			// 100usec
#define		TM2_CNT				3096			// 78usec
												// 3.7328*43/8=39.6288MHz/12.8kHz=3096
#define		TM3_CNT				2200			// 50Hz
												// 3.7328*43/8=39.6288MHz/720=
												// 7.3728*43/4/2=39.63MHz/10kHz=3963

#define		SYSCLOCK			39628800		// 7372800*43/8=39628800

// ԌW

#define		TD10MSPER1MS		10				// 10msec(1msecۯ)


///////////////////////////////////////////////////////////////////////////////
// PWM֌W萔

// PWM

#define		PWM_PERIOD			3146			// 7.3728*32*4=943.7184MHz
												// 943.7184MHz/300kHz=3146

// DcDc1,2PWMݒ

#define		DD1_PWM_MIN			8				// DcDc1ŏPWM
#define		DD2_PWM_MIN			8				// DcDc2ŏPWM


///////////////////////////////////////////////////////////////////////////////
// ϒRl̎擾֌W萔

// ADϊ

#define		RV1_CNT_MAX			128				// RV1̍ő̂Ƃo͓dDC14Vɐݒ
#define		RV2_CNT_MAX			128				// RV2ő̂Ƃo͓d1.5Aɐݒ


///////////////////////////////////////////////////////////////////////////////
// ݔg֌W

#define		PWM_MAG				973				// 1024-51=973
#define		MOTOR_FREQ_MIN		300				// 300Hz
#define		VOLT_MAG			1537			// 1573/1023=1537
#define		VOLT_COEF			227				// 1023/4.5
#define		MOTOR_VOLT_MIN		314				// 1023/2.8*0.86=314

#define		NUM_SINE_MAX		360				// 1

#define		U_PHASE				0				// 0
#define		W_PHASE				60				// 60

#define		CENTER				1573			// (0V) 3146/2


///////////////////////////////////////////////////////////////////////////////
// ۰ϊ֌W̕ϐ

// ϐ

unsigned int shcTM100us __attribute__((__near__));	// 100usec ۯ
unsigned int shcTM1ms __attribute__((__near__));	// 1msec ۯ
unsigned int shcTM10ms __attribute__((__near__));	// 10msec ۯ
unsigned int shcTM100ms __attribute__((__near__));	// 100msec ۯ

// ׸

typedef struct tagTM1FLAGS{
	unsigned int f100us:	1;		// 100usec ۯ׸
	unsigned int f1ms:		1;		// 1mssec ۯ׸
	unsigned int f10ms:		1;		// 10msec ۯ׸
	unsigned int f100ms:	1;		// 100msec ۯ׸
	unsigned int f1s:		1;		// 1sec ۯ׸
}TM1FLAGS;

TM1FLAGS shTM1Flags __attribute__((__near__));			// ۯ׸


//////////////////////////////////////////////////////////////////////////////
// ֌W̕ϐ

// ϐ

unsigned char bycSw1;						// SW1 ON-OFF足

// ׸

typedef struct tagSW{
	unsigned int fSw1:			1;			// SW1׸	1:ON, 0:OFF
	unsigned int fSw1OnOff:		1;			// SW1ėꂽ
	unsigned int fSw1OnHold:	1;			// SW1ONێꂽ
}SW_FLAGS;

SW_FLAGS shSwFlags __attribute__((__near__));	// ׸


///////////////////////////////////////////////////////////////////////////////
// Ӱ

// Ӱސ

unsigned int shDcDc12Mode __attribute__((__near__));		// ^]Ӱ

typedef struct tagCTRLFLAGS{
	unsigned int fFreqChange:		1;						// gύX
}CTRL_FLAGS;

CTRL_FLAGS shDcDc12CtrlFlags __attribute__((__near__));		// DcDc1׸

// Ӱd

unsigned int shMotorVolt __attribute__((__near__));			// Ӱd

// Ӱg

unsigned int shMotorFreq __attribute__((__near__));			// Ӱg

// ް

unsigned int shcNumSine __attribute__((__near__));		// ް̲ޯ
unsigned int shNumSineU __attribute__((__near__));		// U
unsigned int shNumSineV __attribute__((__near__));		// V
unsigned int shNumSineW __attribute__((__near__));		// W

// 

unsigned int shTM3Cnt __attribute__((__near__));		// 3Ēl


///////////////////////////////////////////////////////////////////////////////
// ϒRADϊl擾֌W

// ϐ

unsigned int shRV1Val __attribute__((__near__));		// RV1̒l
unsigned long nsRV1Sum __attribute__((__near__));		// RV1̉Zl
unsigned int shcRV1Cnt __attribute__((__near__));		// RV1̉Z

unsigned int shRV2Val __attribute__((__near__));		// RV2̒l
unsigned long nsRV2Sum __attribute__((__near__));		// RV2̉Zl
unsigned int shcRV2Cnt __attribute__((__near__));		// RV2̉Z

// ׸

typedef struct tagRVFLAGS{
	unsigned int fRVChanged:		1;		 // ϒRύXꂽ
}RV_FLAGS;

RV_FLAGS shRVFlags __attribute__((__near__));	// ϒR׸


///////////////////////////////////////////////////////////////////////////////
//	֐錾

// ֐

void InitCLK(void);						// ۯ̏
void InitIO(void);						// IO߰Ă̏
void InitTM(void);						// TM1-3̏
void InitADC(void);						// ADC̏
void InitPWM(void);						// PWM̏
void InitInt(void);						// 荞݊֌W

// SW1֐

void Sw1OnOffCheck(void);				// Sw1ON-OFFԂ

// Ӱ

void DcDc12ModeChange(void);			// DcDc12̉^]ԂύX
void DcDc12ModeCtrl(void);				// DcDc12^]ԂɉĐ
void CalcuMotorPeriod(void);			// g̐ݒ

//	荞݊֐

void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void);	// TM1荞
void __attribute__((__interrupt__, no_auto_psv)) _T3Interrupt(void);	// TM3荞
void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void);	// ADω߱0荞


///////////////////////////////////////////////////////////////////////////////
// ݔg`ð

const int shSineData[] = {
    0,    18,    36,    54,    71,    89,   107,   125,
  142,   160,   178,   195,   213,   230,   247,   265,
  282,   299,   316,   333,   350,   367,   383,   400,
  416,   432,   448,   464,   480,   496,   512,   527,
  542,   557,   572,   587,   601,   616,   630,   644,
  658,   671,   685,   698,   711,   723,   736,   748,
  760,   772,   784,   795,   806,   817,   828,   838,
  848,   858,   868,   877,   886,   895,   903,   911,
  919,   927,   935,   942,   949,   955,   961,   967,
  973,   978,   983,   988,   993,   997,  1001,  1004,
 1007,  1010,  1013,  1015,  1017,  1019,  1021,  1022,
 1022,  1023,  1023,  1023,  1022,  1022,  1021,  1019,
 1017,  1015,  1013,  1010,  1007,  1004,  1001,   997,
  993,   988,   983,   978,   973,   967,   961,   955,
  949,   942,   935,   927,   919,   911,   903,   895,
  886,   877,   868,   858,   848,   838,   828,   817,
  806,   795,   784,   772,   760,   748,   736,   723,
  711,   698,   685,   671,   658,   644,   630,   616,
  601,   587,   572,   557,   542,   527,   512,   496,
  480,   464,   448,   432,   416,   400,   383,   367,
  350,   333,   316,   299,   282,   265,   247,   230,
  213,   195,   178,   160,   142,   125,   107,    89,
   71,    54,    36,    18,     0,   -18,   -36,   -54,
  -71,   -89,  -107,  -125,  -142,  -160,  -178,  -195,
 -213,  -230,  -247,  -265,  -282,  -299,  -316,  -333,
 -350,  -367,  -383,  -400,  -416,  -432,  -448,  -464,
 -480,  -496,  -512,  -527,  -542,  -557,  -572,  -587,
 -601,  -616,  -630,  -644,  -658,  -671,  -685,  -698,
 -711,  -723,  -736,  -748,  -760,  -772,  -784,  -795,
 -806,  -817,  -828,  -838,  -848,  -858,  -868,  -877,
 -886,  -895,  -903,  -911,  -919,  -927,  -935,  -942,
 -949,  -955,  -961,  -967,  -973,  -978,  -983,  -988,
 -993,  -997, -1001, -1004, -1007, -1010, -1013, -1015,
-1017, -1019, -1021, -1022, -1022, -1023, -1023, -1023,
-1022, -1022, -1021, -1019, -1017, -1015, -1013, -1010,
-1007, -1004, -1001,  -997,  -993,  -988,  -983,  -978,
 -973,  -967,  -961,  -955,  -949,  -942,  -935,  -927,
 -919,  -911,  -903,  -895,  -886,  -877,  -868,  -858,
 -848,  -838,  -828,  -817,  -806,  -795,  -784,  -772,
 -760,  -748,  -736,  -723,  -711,  -698,  -685,  -671,
 -658,  -644,  -630,  -616,  -601,  -587,  -572,  -557,
 -542,  -527,  -512,  -496,  -480,  -464,  -448,  -432,
 -416,  -400,  -383,  -367,  -350,  -333,  -316,  -299,
 -282,  -265,  -247,  -230,  -213,  -195,  -178,  -160,
 -142,  -125,  -107,   -89,   -71,   -54,   -36,   -18,
    0,    18,    36,    54,    71,    89,   107,   125,
  142,   160,   178,   195,   213,   230,   247,   265,
  282,   299,   316,   333,   350,   367,   383,   400};


