/******************************************************************************
	DAv											2010 Masaji Kasahara
	libdsp-coff.aN
******************************************************************************/

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <stdlib.h>
#include <math.h>
#include <dsp.h>
#include "my.h"

_FOSCSEL(FNOSC_FRC);		// NFRCB(NPLLɐ؂ւ)
_FOSC(POSCMD_NONE & OSCIOFNC_ON & FCKSM_CSECMD & IOL1WAY_OFF);
_FWDT(FWDTEN_OFF);			// EHb`hbO^C}֎~

#define PERIOD 2404			// XCb`Og = 1/1.04ns/PERIOD = 400kHz

unsigned peak_meter;		// 荞݃[`main()ɐM̃s[Nʒm

// M傫ĖOaƂ荞݃[`烁C[`ɓ`萔
#define CLIP_IN		65535	// ADCOa
#define CLIP_OUT	65534	// PWMOa

// menu[`ŎgϐBڂmenu.cQƁB
MENU_VAL volume=6, geq[GEQNumSections];
#define MENU_NO		5
struct menu_dat menu_dats[MENU_NO] = {
	// type,       str,    *value, max,min,row,column,curpos
	{ INT_MENU,    "20",   &volume, 15,  0,  1,   1,    0  },
	{ INT_MENU,    "+9",   geq+0 ,   9, -9,  1,   4,    0  },
	{ INT_MENU,    "+9",   geq+1 ,   9, -9,  1,   7,    0  },
	{ INT_MENU,    "+9",   geq+2 ,   9, -9,  1,  10,    0  },
	{ INT_MENU,    "+9",   geq+3 ,   9, -9,  1,  13,    0  }
};


int main( void )
{
	int peak_timer=0, peak_disp;
	init();				// 	
	soft_start();		// |bvmCYጸ̂ߒdXɏグ
	GEQ_init();			// OCRIIRtB^
	SET_CPU_IPL( 0 );	// 荞݋
	lcd_init();			//LCD
	LCD_LOCATE( 0, 0 );	lcd_str( "Pk0 .15 2  6 20k" );	// j[\
	LCD_LOCATE( 1, 0 );	lcd_str( "V10  0  0  0  0" );
	while(1){
		menu( menu_dats, MENU_NO );	// [U[C^tF[X
		calc_geqcoef( geq );		// OCR̃tB^WvZ
		if(peak_timer-- == 0){		// 0.5bɈs[Nx\
			peak_timer = 50;
			if     (peak_meter == CLIP_IN)	peak_disp = 'c';
			else if(peak_meter == CLIP_OUT)	peak_disp = 'C';
			else if(peak_meter & 0xC000)	peak_disp = '7';
			else if(peak_meter & 0x2000)	peak_disp = '6';
			else if(peak_meter & 0x1000)	peak_disp = '5';
			else if(peak_meter & 0x0800)	peak_disp = '4';
			else if(peak_meter & 0x0400)	peak_disp = '3';
			else if(peak_meter & 0x0200)	peak_disp = '2';
			else if(peak_meter & 0x0100)	peak_disp = '1';
			else							peak_disp = '0';
			LCD_LOCATE( 0, 2 );	lcd_data( peak_disp );
			peak_meter = 0;
		}
	}
}


enum ch_sel{ LEFT_CH, RIGHT_CH };
static unsigned ch_calc( unsigned ad_in, int mix_in, enum ch_sel ch );
// ADCyA2荞(pC30[U[KCh TABLE 8-2)
void __attribute__((interrupt, no_auto_psv))_ADCP0Interrupt(void)
{
	static unsigned left, right;
	LED = 0;		// TP9ϑΊ荞ݏԂ

	PDC1 = left;	// ǑvZʂo
	PDC2 = right;

	left  = ch_calc( ADCBUF0, 0, LEFT_CH );	// vZ(8s)
	right = ch_calc( ADCBUF1, 0, RIGHT_CH );
	
	_ADCP0IF = 0;	// ADCyA0荞݃tONA
	LED = 1;
}


extern IIRTransposedStruct GraphicEqualizer[2];
// `lƂɃ{EAOCRAs[N[^B
static unsigned ch_calc( unsigned ad_in, int mix_in, enum ch_sel ch )
{
	unsigned abs_val;
	fractional value;
	const int numsamp = 1;	// xIIRTransposed()ĂяoŌvZTv
	
	value = ad_in - 512;	// ADϊʂ𕄍tɕϊ(ĺ͈}512)
	
	value *= (volume&0x0001)? 64: 45;	// volume(3dB step)
	value += mix_in;
	value >>= (15-volume) / 2;			// (l͈ }32768)

	IIRTransposed(numsamp, &value, &value, &(GraphicEqualizer[ch]));

	if(ad_in==0 || 1023==ad_in)
		peak_meter = CLIP_IN;
	abs_val = abs(value);		// s[N[^
	if(peak_meter < abs_val)	// őUpeak_meterɃz[h
		peak_meter = abs_val;
	
	value = (value>>4) + 1241;	// xEDACo͗pɒxVtg
	if(value>2335){				// NbsO
		value = 2335;
		peak_meter = CLIP_OUT;
	}
	else if(value<224){			// NbsO(̃n[hł͍߂
		value = 224;			// NbsOKvAŏIn[h
		peak_meter = CLIP_OUT;	// ł12܂ŉđvłB
	}
	return value;
}


void init(void)
{
	SET_CPU_IPL( 7 );		// 荞݋֎~
	Nop();
	NJW4800_STBY = 1;
	TRISA = 0x0007;			// 1̃rbg͓̓s
	TRISB = 0xC741;			// 1̃rbg͓̓s

	// NbNFRC+PLLɐ؂ւ39.6MIPSɂ
	// (IV[^{}jAp42-23,42-2)
	PLLFBD = 41;					// PLL M = 43
	CLKDIVbits.PLLPOST = 0;			// PLL N1 = 2
	CLKDIVbits.PLLPRE = 0;			// PLL N2 = 2
	__builtin_write_OSCCONH(0x01);	// FRC+PLLɐ؂ւJn
	__builtin_write_OSCCONL(0x01);
	while(OSCCONbits.COSC != 0b001);// NbN؂ւ҂
	while(OSCCONbits.LOCK != 1);	// PLLbN҂

	// ADC/PWMW[p⏕NbN(ACLK)FRC+⏕PLL(16{)117.9MHzɂ
	ACLKCONbits.FRCSEL = 1;			// ⏕PLLFRC
	ACLKCONbits.SELACLK = 1;
	ACLKCONbits.APSTSCLR = 7;
	ACLKCONbits.ENAPLL = 1;			// ⏕PLLCl[u
	while(ACLKCONbits.APLLCK != 1);	// ⏕PLLbN҂
	
	// PWMݒ
	PWMCON1bits.ITB = 0;	// }X^[^Cx[X[h
	PWMCON2bits.ITB = 0;
	PWMCON1bits.CAM = 0;	// GbWAC[h
	PWMCON2bits.CAM = 0;
	IOCON1bits.PMOD = 0;	// o̓[h
	IOCON2bits.PMOD = 0;
	PTCONbits.PTEN  = 1;	// PWMW[L
	PWMCON1bits.DTC = 2;	// fbh^C@\
	PWMCON2bits.DTC = 2;
	PTPER = PERIOD;			// }X^[^Cx[X XCb`Og400kHz
	IOCON1bits.PENH = 1;	// PWMW[PWM1H/PWM2Hs𐧌
	IOCON2bits.PENH = 1;
	
	// A/DRo[^ TvO()
	ADCONbits.EIE = 0;		// ADCyAϊIĂ犄荞
	ADCONbits.FORM = 0;		// A/Dʂ1:Œ菬///////////0:unsigned int
	ADCONbits.SLOWCLK = 1;	// ACLK(117.92M)gp(Gb^FK1ɂ邱)
	ADCONbits.ADCS = 4;		// ADNbNFADC/5 = 23.584MHz
	TRIG1bits.TRGCMP = 0;	// PWMWFl[^1APWMʑ0ŃgKo
	TRGCON1bits.TRGDIV = 8;	// PWMpX91TvO(44.4ksps)
	_TRGSRC0 = 4;			// PWMWFl[^11gKADCyA0(AN0,AN1)ϊ
	ADPCFG = 0;				// SAiO̓sADCƂĎgpAiO[h
	IPC27bits.ADCP0IP = 2;	// ADCyA0荞݃x2
	IFS6bits.ADCP0IF = 0;	// ADCyA0荞݃tONA
	IEC6bits.ADCP0IE = 1;	// ADCyA0荞݋
	ADCONbits.ADON = 1;		// ADCW[Cl[u

	RCON=0;		// sӂɃZbgƂɃfobKRCON𒲂ׂƗv
}


void soft_start( void )
{
	int count;
	PDC1 = PDC2 = 100;
	
	NJW4800_STBY = 0;		// NJW4800o͊Jn
	
	for( count=100; count<PERIOD/2; count++ ){
		delay(500);			// 500sfBC
		PDC1 = PDC2 = count;
	}
}
